@echo off
rem  **************************************************************************
rem  **                                                                      **
rem  **         Installation Batch File:                                     **
rem  **         GENOA 8000 series boards                                     **
rem  **                   and                                                **
rem  **               Generic CADD                                           **
rem  **                                                                      **
rem  **************************************************************************
cls
echo .
echo Device Driver Install Disk
echo for Generic Software products and the GENOA 8000 series board(s)
echo .
echo Please wait a moment while I find which applications are installed...
echo .
rem
rem first, make certain we're not logged onto the A drive
rem
if NOT EXIST install.bat goto Contin
if NOT EXIST readme.bat goto Contin
if NOT EXIST readme.doc goto Contin
rem
rem since we are, lets go to the C: drive
rem
c:
cd \
echo Searching for Generic products on C: drive
goto ins_lv2
:Contin
echo Searching for Generic products on the default drive
cd \
:ins_lv2
if EXIST a:install.sta del a:install.sta
if NOT EXIST \level2\cadd.exe goto ins_lv3
echo CADD Level 2 found
echo please wait while files are copied
cd \level2
copy a:lgenvdd.vgd lgenvdd.vgd > a:install.sta
echo .
copy a:sgenvdd.vgd sgenvdd.vgd > a:install.sta
echo .
copy a:read.me read.me > a:install.sta
echo .
echo Please configure Level 2 for "GENOA VGA"
pause
config
echo Generic CADD Level 2 driver installation complete
:ins_lv3
if NOT EXIST \level3\cadd.exe goto ins_3dd
echo CADD Level 3 found
echo please wait while files are copied
cd \level3
copy a:lgenvdd.vgd lgenvdd.vgd > a:install.sta
echo .
copy a:sgenvdd.vgd sgenvdd.vgd > a:install.sta
echo .
echo Please configure Level 3 for "GENOA VGA"
pause
config
echo Generic CADD Level 3 driver installation complete
:ins_3dd
if NOT EXIST \3dd\3dd.exe goto ins_cad5
echo 3D Drafting found
echo please wait while files are copied
cd \3dd
copy a:lgenvdd.vgd lgenvdd.vgd > a:install.sta
echo .
copy a:sgenvdd.vgd sgenvdd.vgd > a:install.sta
echo .
echo Please configure 3DD for "GENOA VGA"
pause
3dconfig
echo Generic CADD 3DD driver installation complete
:ins_cad5
if NOT EXIST \cadd5\gcadd.exe goto All_Done
echo CADD 5.0 found
echo please wait while files are copied
cd \cadd5
copy a:lgenvdd.vgd lgenvdd.vgd > a:install.sta
echo .
copy a:sgenvdd.vgd sgenvdd.vgd > a:install.sta
echo .
echo Please configure CADD 5.0 for "GENOA VGA"
echo In order to select this driver, you must first
echo select the "other VGDs" option.
pause
config
echo Generic CADD 5.0 driver installation complete
goto All_Done
:USAGE
echo .
echo In order to be installed correctly, the following conditions must
echo be true:
echo .
echo   *   This install disk must be in drive A
echo   *   The install disk cannot be write protected
echo   *   The CURRENT drive must contain Level 2, Level 3, CADD 5.0 or 3DD
echo .
echo No other exceptions are allowed by this installation program.
echo .
echo To install in non-standard directories, please refer to the instructions
echo in the manual. (A:READ.ME)
goto end
:All_Done
rem
rem Here we will tell the user that installation is complete
rem
if NOT EXIST a:install.sta goto USAGE
del a:install.sta
echo GENERIC CADD driver installation is now complete!
:end
