; Stereoscopic pix of rotating hypercube.
; Final version (hopefully):  32-bit rotation, 16-bit display

                                        ; All publics in this file are for
                                        ; the benefit of SYMDEB -- not LINK!

         assume   cs:code, ds:data, ss:stack
         page     80,132
         .lall

;
; constants and declarations
;

Scale    equ       16777216             ; 3 bytes to the right of the decimal
MaxSpeed =         5                    ; no more than five in any direction
C        equ       16771467             ; cos(1.5) * Scale
S        equ         439176             ; sin(1.5) * Scale
_        equ        -439176             ; -sin(1.5) * Scale
SterCos  equ       16685309             ; cos(6) * Scale
SterSin  equ        1753697             ; sin(6) * Scale
_SterSin equ       -1753697             ; sin(6) * Scale

HiScale  equ            100h
LoScale  equ              0H
l        equ       16777216             ; l "=" 1
_l       equ      -16777216             ; -1

; C        equ       16754223             ; cos(3) * Scale
; S        equ         878052             ; sin(3) * Scale
; _        equ        -878052             ; -sin(3) * Scale
; C        equ       16771467             ; cos(1.5) * Scale
; S        equ         439176             ; sin(1.5) * Scale
; _        equ        -439176             ; -sin(1.5) * Scale
; C        equ       16774661             ; cos(1) * Scale
; S        equ         292803             ; sin(1) * Scale
; _        equ        -292803             ; -sin(1) * Scale
; C        equ       16775779             ; cos(.75) * Scale
; S        equ         219607             ; sin(.75) * Scale
; _        equ        -219607             ; -sin(.75) * Scale

;
;  stack segment
;

stack    segment  stack
         db       100 dup ('* stack ')
stack    ends

;
;  globally important data
;

data     segment  word public

         public   RghtCube, LeftCube, Tmp, Canonic
         public   Rotate, UnitRot, Stereo, Identity
         public   RghtVert, LeftVert

Canonic  dd       _l, _l, _l, _l
         dd       _l, _l, _l,  l
         dd       _l, _l,  l, _l
         dd       _l, _l,  l,  l
         dd       _l,  l, _l, _l
         dd       _l,  l, _l,  l
         dd       _l,  l,  l, _l
         dd       _l,  l,  l,  l
         dd        l, _l, _l, _l
         dd        l, _l, _l,  l
         dd        l, _l,  l, _l
         dd        l, _l,  l,  l
         dd        l,  l, _l, _l
         dd        l,  l, _l,  l
         dd        l,  l,  l, _l
         dd        l,  l,  l,  l
RghtCube dd        16 * 4 dup (?)
LeftCube dd        16 * 4 dup (?)
Tmp      dd        16 * 4 dup (?)

Identity dd        l, 0, 0, 0              ; identity matrix; 0 rotation
         dd        0, l, 0, 0
         dd        0, 0, l, 0
         dd        0, 0, 0, l

Rotate   dd        4 * 4 dup (?)           ; current rotation

UnitRot  dd        C, S, 0, 0              ; x-y rotation
         dd        _, C, 0, 0
         dd        0, 0, l, 0
         dd        0, 0, 0, l

         dd        C, 0, S, 0              ; x-z rotation
         dd        0, l, 0, 0
         dd        _, 0, C, 0
         dd        0, 0, 0, l

         dd        C, 0, 0, S              ; x-t rotation
         dd        0, l, 0, 0
         dd        0, 0, l, 0
         dd        _, 0, 0, C

         dd        l, 0, 0, 0              ; y-z rotation
         dd        0, C, S, 0
         dd        0, _, C, 0
         dd        0, 0, 0, l

         dd        l, 0, 0, 0              ; y-t rotation
         dd        0, C, 0, S
         dd        0, 0, l, 0
         dd        0, _, 0, C

         dd        l, 0, 0, 0              ; z-t rotation
         dd        0, l, 0, 0
         dd        0, 0, C, S
         dd        0, 0, _, C

         dd        C, _, 0, 0              ; x-y antirotation
         dd        S, C, 0, 0
         dd        0, 0, l, 0
         dd        0, 0, 0, l

         dd        C, 0, _, 0              ; x-z antirotation
         dd        0, l, 0, 0
         dd        S, 0, C, 0
         dd        0, 0, 0, l

         dd        C, 0, 0, _              ; x-t antirotation
         dd        0, l, 0, 0
         dd        0, 0, l, 0
         dd        S, 0, 0, C

         dd        l, 0, 0, 0              ; y-z antirotation
         dd        0, C, _, 0
         dd        0, S, C, 0
         dd        0, 0, 0, l

         dd        l, 0, 0, 0              ; y-t antirotation
         dd        0, C, 0, _
         dd        0, 0, l, 0
         dd        0, S, 0, C

         dd        l, 0, 0, 0              ; z-t antirotation
         dd        0, l, 0, 0
         dd        0, 0, C, _
         dd        0, 0, S, C

;Stereo   dd        SterCos,  0, SterSin, 0 ; 1-3 hyperstereo rotation matrix
;         dd        0, Scale, 0,          0
;         dd        _SterSin, 0, SterCos, 0
;         dd        0, 0,     0,          Scale

Stereo   dd        SterCos,  0, 0, SterSin ; 1-4 hyperstereo rotation matrix
         dd        0, Scale, 0, 0
         dd        0, 0, Scale, 0
         dd        _SterSin, 0, 0, SterCos

RghtVert dw        16 * 2 dup (?)
LeftVert dw        16 * 2 dup (?)

data     ends

;
; code
;

code     segment  byte public

;
;  Low level stuff
;

include  random.h                       ;proc RANDOMIZ & RANDOM; macro RAND(N)

extrn    ClrAScrn:near
extrn    SetPScrn:near
extrn    Draw:    near                  ; draw line from (Row1,Col1) to (Row2,Col2)
                                        ; in color bp; 320x200 modes.
                                        ; cx:dx = (Row1,Col1), si:di = (Row2,Col2)

Cons     macro    Msg                   ; assumes Msg is in DS
         mov      ah,9
         mov      dx,offset msg
         int      21h
         endm

HiRes    macro
         mov      ax,6                  ; 640x200 hi-res graphics
         int      10h                   ; call BIOS to change modes
         endm

TextMode macro
         mov      ax,3                  ; 80x25 color
         int      10h                   ; call BIOS to change modes
         endm

Copy     macro    To, From, N, Mode     ; copy objects within ds
         mov      ax,ds
         mov      es,ax
         mov      si,offset From
         mov      di,offset To
         mov      cx,N                  ; number of items to move
         cld                            ; make sure we INCREMENT di, si
         rep      movs&Mode             ; do the copy
         endm

ByeBye   macro
         mov     ax,4c00h               ; go bye-bye with result code = 0
         int     21H                    ; see ya!
         endm

         public   KeyPress
KeyPress proc     near                  ; Z-flag clr ==> KeyPress
         mov      ah,06                 ; DOS "direct console i/o" fn
         mov      dl,0ffh               ; read a byte
         int      21h                   ; call DOS
         ret                            ; char (if any) is in AL!
KeyPress EndP

Click    proc     near
         in       al,61h                ; get ppi port
         xor      al,02h                ; toggle speaker data byte
         out      61h,al                ; write ppi port
         mov      cx,3                  ; wait a little so can hear click
killtime:loop     killtime              ; kill time
         xor      al,02h                ; untoggle speaker data byte
         out      61h,al                ; rewrite ppi port
         ret
Click    endp

;
;  32-bit math
;

Neg32    macro    Hi,Lo                  ; NEGate dword by (NOT dword)+1
         not      Lo                     ; 1's complement ...
         not      Hi
         add      Lo,1                   ; ... + 1 = 2's complement
         adc      Hi,0
         endm

         public   Mul32
MUL32    proc     near                   ; ax:bx:cx:dx := bx:cx mul si:di
         push     bp                     ; save global bp
         mov      bp,sp                  ; frame pointer
         sub      sp,6                   ; 3 local words

R3       equ      word ptr [bp-2]        ; second word of result
R2       equ      word ptr [bp-4]        ; third word
R1       equ      word ptr [bp-6]        ; fourth (low) word of result

         mov      ax,cx                  ; Left[Low]
         mul      di                     ; Left[Low] * Right[Low]
         mov      R1,ax                  ; low result word
         mov      r2,dx                  ; high result word
         mov      ax,bx                  ; Left[High]
         mul      di                     ; Left[High] * Right[Low]
         add      r2,ax                  ; add low result to prev high
         adc      dx,0                   ; add the carry bit
         mov      r3,dx                  ; high word of result
         mov      ax,cx                  ; Left[Low]
         mul      si                     ; Left[Low] * Right[High]
         add      r2,ax                  ; stash results one word over
         adc      r3,dx                  ; high word of result
         mov      ax,bx                  ; Left[High]
         mul      si                     ; Left[High] * Right[High]
         add      r3,ax                  ; low word
         adc      dx,0                   ; add carry bit to high word
         mov      ax,dx                  ; high word of result
         mov      bx,r3
         mov      cx,r2
         mov      dx,r1                  ; low word

         mov      sp,bp                  ; delocalize
         pop      bp                     ; restore bp
         ret
MUL32    endp

         public   IMUL32
IMUL32   proc     near                   ; ax:bx:cx:dx := bx:cx imul si:di
         push     bx                     ; save left high word
         test     bx,8000h               ; check the high bit
         jz       i_lpos                 ; positive?
         Neg32    bx,cx                  ; change sign of dword
i_lpos:  push     si                     ; save right high word
         test     si,8000h               ; check the high bit
         jz       i_doit                 ; positive?
         Neg32    si,di                  ; change sign of dword
i_doit:  call     MUL32                  ; multiply two positive numbers
         pop      si                     ; get back high words
         pop      di
         xor      si,di                  ; bitwise xor
         rcl      si,1                   ; get the xor-ed sign bit
         jnc      i_done                 ; equal sign bits mean result is +
         not      dx                     ; else ax:bx:cx:dx := -ax:bx:cx:dx =
         not      cx                     ; NOT ax:bx:cx:dx ...
         not      bx
         not      ax
         add      dx,1                   ; ... + 1
         adc      cx,0
         adc      bx,0
         adc      ax,0
i_done:  ret                             ; ax:bx:cx:dx: := bx:cx imul si:di
IMUL32   endp

Unscale  macro
         mov      dl,ch                  ;; shift ax:bx:cx:dx right 24 bits
         mov      dh,bl
         mov      cl,bh
         mov      ch,al
         endm

;
;  rotation (matrix math) routines
;

         public   MatMul
MatMul   proc     near                   ; multiply matrix [SP+4] by [SP+2]
                                         ; into [Tmp]
         mov      bp,sp                  ; base pointer
         sub      sp,8                   ; 2 local words; 1 dword

Left     equ      word ptr [bp+6]        ; offset of left arg
Right    equ      word ptr [bp+4]        ; offset of second arg
I        equ      word ptr [bp+2]        ; start of current row in left arg

J        equ      word ptr [bp-2]        ; top of current row in right arg
K        equ      word ptr [bp-4]        ; inner loop counter
LoAccum  equ      word ptr [bp-6]        ; low word of dword accumulator
HiAccum  equ      word ptr [bp-8]        ; high word of dword accumulator

mm_itop: mov      J,3 * 4                ; dword index 3 downto 0
mm_jtop: mov      LoAccum,0              ; zero low word of accumulator
         mov      HiAccum,0              ; zero high word of accumulator
         mov      bx,Left                ; Left[0, 0]
         add      bx,I                   ; Left[I, 0]
         mov      si,J                   ; [0, J]
         add      si,Right               ; Right[0, J]
         mov      K,4                    ; 4 rows/columns
mm_ktop: push     bx                     ; we need to preserve bx, si
         push     si                     ; (math routines preserve bp)
         mov      cx,[bx]                ; LoWord( Left[I, K] )
         mov      bx,[bx+2]              ; HiWord( Left[I, K] )
         mov      di,[si]                ; LoWord( Right[K, J] )
         mov      si,[si+2]              ; HiWord( Right[K, J] )
         call     IMUL32                 ; ax:bx:cx:dx := bx:cx IMUL di:si
         Unscale                         ; shift ax:bx:cx:dx right 24 bits
         pop      si                     ; restore ptrs
         pop      bx
         add      LoAccum,dx             ; add low word to accumulator
         adc      HiAccum,cx             ; add high word
         add      bx,4                   ; point to the next item in row
         add      si,16                  ; point to the next item in col
         dec      K                      ; for K := 4 downto 1 ...
         jnz      mm_ktop                ; inner loop runs four times

         mov      bx,I                   ; [I, 0]
         add      bx,J                   ; [I, J]
         mov      cx,HiAccum             ; read accumulator into registers
         mov      dx,LoAccum             ; so we can write it back to mem
         mov      word ptr Tmp[bx],dx    ; Tmp[I, J] := LoWord(Accum)
         mov      word ptr Tmp[bx+2],cx  ;              HiWord(Accum)
         sub      J,4                    ; decrement by a dword
         jge      mm_jtop                ; middle loop runs four times
         sub      I,16                   ; decrement by a row
         jge      mm_itop                ; run until new I < 0

         mov      sp,bp                  ; delocalize
         ret      6                      ; return & clr args
MatMul   endp

Multiply macro    Result, Left, Right
         mov      ax,offset Left
         push     ax
         mov      ax,offset Right
         push     ax
         mov      ax,(16 - 1) * 16        ;; pointer to start of last row
         push     ax
         call     MatMul
         Copy     Result,Tmp,128,W
         endm

data     segment  word public
         public   Speeds
Speeds   db       6 dup (0)              ; # of unit rotations in each plane
data     ends

         public   NewRot
NewRot   proc     near
         mov      ax,offset Rotate       ; we're going to multiply Rotate by
         push     ax                     ; one of the UnitRotations
n_select:Rand     12                     ; ax := 0..11
         mov      bx,offset Speeds       ; "speed table"
         mov      si,ax                  ; copy it for testing
         cmp      si,6                   ; compare it to 6
         jge      n_anti                 ; an antirotation
         lea      si,[bx+si]             ; position of the current "speed"
         mov      bl,[si]                ; get the current "speed"
         inc      bl                     ; we'd be increasing it
         jmp      n_testit               ; compare it to MaxSpeed
n_anti:  lea      si,[bx+si-6]           ; position of the current "speed"
         mov      bl,[si]                ; get the current "speed"
         dec      bl                     ; we'd be decreasing it
n_testit:cmp      bl,MaxSpeed            ; compare it to the maxspeed
         ja       n_select               ; repeat if bl > MaxSpeed
         cmp      bl,-MaxSpeed           ; compare to minspeed
         js       n_select               ; repeat if bl + MaxSpeed < 0
         mov      [si],bl                ; write back new speed and proceed
         mov      cl,6                   ; 64 bytes/UnitRotation
         shl      ax,cl                  ; offset into UnitRotations
         add      ax,offset UnitRot      ; offset of a specific UnitRotation
         push     ax                     ; second arg to MatMul
         mov      ax,(4 - 1) * 16        ; pointer to last row start
         push     ax                     ; all args on stack
         call     MatMul                 ; Tmp := Rotate +.x UnitRotation
         Copy     Rotate,Tmp,32,W        ; Rotate := Tmp
         ret
NewRot   endp

;
;  display routines
;

VP       =        HiScale * 50           ; one word ...
RowOfs   =        100                    ; image centers, in pixels
RightOfs =        425
LeftOfs  =        215
RowAspct =        HiScale / 25           ; Unscaling by this cnvrts 1 to 25
ColAspct equ      HiScale / 61

data     segment  word public
         public   Euler
Euler    db        0 * 4,  1 * 4,  3 * 4,  2 * 4,  6 * 4, 14 * 4 ; row starts
         db       10 * 4,  8 * 4,  9 * 4, 11 * 4,  3 * 4,  7 * 4 ; in ?Vert
         db       15 * 4, 14 * 4, 12 * 4, 13 * 4,  9 * 4,  1 * 4
         db        5 * 4,  7 * 4,  6 * 4,  4 * 4, 12 * 4,  8 * 4
         db        0 * 4,  4 * 4,  5 * 4, 13 * 4, 15 * 4, 11 * 4
         db       10 * 4,  2 * 4,  0 * 4
data     ends

         public   Display, d_draw
Display  proc     near
         mov      bp,sp                  ; set frame ptr
         sub      sp,6                   ; 2 words and a byte

Eulr     equ      word ptr [bp-2]
EulrP1   equ      word ptr [bp-4]
Idx      equ      word ptr [bp-6]

         mov      Idx,15                  ; 16 (x2) vertices to project
d_ptop:  mov      di,Idx
         shl      di,1
         shl      di,1                   ; ?Vert[Idx,0]
         mov      si,di                  ; we need to index ?Cube, too.
         shl      si,1
         shl      si,1                   ; ?Cube[Idx, 0]

Project  macro    Cube,Vert,ColOfs
         mov      bx,word ptr Cube[si+8] ;; Cube[Idx,2]
         mov      ax,word ptr Cube[si+10]
         xor      dx,dx                  ;; LoWord(VanishingPoint)
         mov      cx,VP                  ;; high word
         sub      dx,bx                  ;; VanishingPoint - Cube[Idx, 2]
         sbb      cx,ax
         add      dx,1                   ;; round to 16 bits
         adc      cx,0
         mov      dx,32h                 ;; HiDword(VP * Scale * Scale)
         xor      ax,ax
         idiv     cx                     ;; VP / (VP - Cube[])
         mov      cx,ax                  ;; save Depth ratio

SetVert  macro    Dim,Aspect,Origin
         mov      bx,word ptr Cube[si+(Dim*4)]   ;; LoWord( Cube[Idx,0/1] * Scale )
         mov      ax,word ptr Cube[si+(Dim*4)+2] ;; HiWord( Cube[Idx,0/1] * Scale )
         add      bx,1                   ;; round to 16 bits
         adc      ax,0
         imul     cx                     ;; Cube[Idx,0/1] * Depth * Scale**2
         mov      al,ah                  ;; shift result dword right one byte
         mov      ah,dl
         add      ax,HiScale / 2         ;; add Scale / 2 (.5)
         cwd                             ;; sign extend ax to dx:ax
         mov      bx,Aspect              ;; see comment by ColAspct
         idiv     bx                     ;; totally unscale
         add      ax,Origin              ;; convert C/R to screen coordinates
         mov      Vert[di+(Dim*2)],ax    ;; write projected vertice
         endm

         SetVert  0,ColAspct,ColOfs
         SetVert  1,RowAspct,RowOfs
         endm

         Project  RghtCube,RghtVert,RightOfs ; right image vertices
         Project  LeftCube,LeftVert,LeftOfs  ; left image vertices
         sub      Idx,1                  ; (DEC doesn't set carry flag...)
         jb       d_draw                 ; do for Idx := 15 downto 0
         jmp      d_ptop                 ; repeat as long as Idx >= 0
d_draw:  call     ClrAScrn               ; clear alternate screen
         mov      cx,32
d_dtop:  mov      bx,cx                  ; Idx
         mov      ah,0                   ; clear ah
         mov      al,Euler[bx-1]         ; Euler[Idx] (Idx is in origin 1)
         mov      Eulr,ax
         mov      si,ax
         mov      al,Euler[bx]           ; Euler[Idx+1]
         mov      EulrP1,ax
         mov      di,ax

DrawVert macro    Vert
         push     cx                     ;; preserve loop counter
         push     bp                     ;; preserve base pointer
         mov      cx,Vert[si+2]          ;; start row
         mov      dx,Vert[si]            ;; start col
         mov      si,Vert[di+2]          ;; stop row
         mov      di,Vert[di]            ;; stop col
         mov      bp,1                   ;; "color" to draw
         call     Draw                   ;; draw the line
         pop      bp                     ;; restore base pointer
         pop      cx                     ;; restore loop counter
         endm

         DrawVert RghtVert               ; draw right line
         mov      si,Eulr                ; restore ptrs to Vert
         mov      di,EulrP1
         DrawVert LeftVert               ; draw right line
         loop     d_dtop                 ; do this 32 times
         call     SetPScrn               ; physical_screen := alternate_screen
         mov      sp,bp                  ; delocalize
         ret
Display  endp

data     segment  word public
         public   Count
Count    dw       ?
data     ends

         public   Tumble
Tumble   proc     near
t_top:   call     NewRot                 ; change the rotation angle
         call     Click
         mov      [Count],30             ; tumble 30 times
t_for:   Multiply LeftCube,RghtCube,Stereo ; Make stereo image
         call     Display                ; display before rotation
         Multiply RghtCube,RghtCube,Rotate ; Rotate Cube
         dec      [Count]                ; Count := Count - 1
         jnz      t_for                  ; for Count := 25 downto 1 ...
         call     KeyPress               ; check kbd
         jz       t_top                  ; repeat until KeyPress
         ret
Tumble   endp

;
;  Initialization
;

data     segment word public

NeedCGA  db      13,10,
         db      'Sorry, this program requires graphics.',13,10,'$'

HelloMsg db      13,10
         db      'HYPERTUMBLE:  Copyright (C) 1986 by  Jon Shemitz',13,10,10
         db      'Press R to reset position and rotation; any other key to stop.',13,10
         db      'Press any key to begin:  $'

data     ends

         public  Init
Init     proc    near
         mov     ax,seg data            ; get data offset
         mov     ds,ax                  ; set data segment
         int     11h                    ; equipment determination
         and     ax,0030h               ; isolate the video bits
         cmp     ax,0030h               ; are both set?
         jne     i_ok                   ; no: color board
         Cons    NeedCGA                ; say why we're quitting
         ByeBye                         ; and go home
i_ok:    Cons    HelloMsg               ; "Press any key to begin"
i_kwait: call    KeyPress               ; check kbd
         jz      i_kwait                ; repeat ... until KeyPress
         call    Randomiz               ; set RandSeed
         HiRes                          ; 640x200 hires graphics
         ret
Init     endp

         public  Reset
Reset    proc    near
         Copy    Rotate,Identity,32,W
         Copy    RghtCube,Canonic,128,W
         ret
Reset    endp

;
;  Here we go...
;

data     segment word public
ByeMsg   db      '  HYPERTUMBLE  ',13,10,10,
         db      '   Copyright (C) 1986 by'    ,13,10,10
         db      '         Jon Shemitz'        ,13,10,10
         db      '   Emerald City Software'    ,13,10
         db      '          Box 1001'          ,13,10
         db      'Ben Lomond, California 95005',13,10,10
         db      '       (408) 336-3354'       ,13,10
         db      '    (408) 336-3134 (bbs)'    ,13,10,10
         db      '',13,10,10,'$'
data     ends

Main:    call    Init                   ; set DS; Randomize; HiRes
m_reset: call    Reset                  ; RghtCube:=Canonic; Rotate:=Identity
         call    Tumble                 ; Tumble until KeyPressed
         and     al,11011111b           ; make char upper case
         cmp     al,'R'                 ; is it a Reset?
         je      m_reset                ; start over if so, else ...
         TextMode                       ; back to text mode
         Cons    ByeMsg                 ; bore the user
         ByeBye                         ; DOS fn 4C

code     ends
         end     Main
