echo off

cls

@echo    
@echo   This updater will update the version of IntelliDraw in the directory
@echo   you specified on the command line - if you specified no directory
@echo   it will attempt to update in the c:\IDRAW20\ directory.  If you need
@echo   to change the directory press Control-C now.
@echo    

pause

@echo    
@echo   IntelliDraw is now being updated to 2.01, the 2.0 version of 
@echo   IntelliDraw will be saved as IDRAW.200, the new version will take
@echo   the place of the older version.
@echo    

if "%1" == "" goto DEFPATH

set IDPATH=%1
goto START

:DEFPATH
set IDPATH=c:\idraw20

:START
if exist %IDPATH%\idraw.exe goto PATCH
@echo    
@echo   IntelliDraw 2.0  ( %IDPATH%\IDRAW.EXE ) not found, make sure that
@echo   you specified the proper directory if it is different than
@echo   c:\idraw20, and that idraw.exe is present in that directory.
@echo    
goto FAIL

:PATCH
@echo    
@echo   Updating IntelliDraw...
@echo    

copy %IDPATH%\idraw.exe %IDPATH%\idraw.200

if errorlevel 1 goto FAIL

copy patch.exe %IDPATH%\patch.exe
copy patch.rtp %IDPATH%\patch.rtp
copy patch.rtd %IDPATH%\patch.rtd

if errorlevel 1 goto FAIL

%IDPATH%\patch.exe %IDPATH% %IDPATH%\patch.rtp

if errorlevel 1 goto FAIL

ren %IDPATH%\idraw.201 idraw.exe

del %IDPATH%\PATCH.EXE > nul
del %IDPATH%\PATCH.RTP > nul
del %IDPATH%\PATCH.RTD > nul

@echo   Updating clip-art files...
if exist %IDPATH%\clipart\spacepln\dimenobj.idw goto COPY
@echo    
@echo   Clip-art file ** %IDPATH\%clipart\spacepln\dimenobj.idw ** not
@echo   found, file was not updated.
@echo    
goto SUCCESS

:COPY
copy dimenobj.idw %IDPATH%\clipart\spacepln\dimenobj.idw

:SUCCESS
@echo    
@echo   Updating of IntelliDraw 2.01 is complete, please make sure to read 
@echo   README.TXT file.
@echo    
@echo   You may delete the following file:
@echo        IDRAW.200
@echo    

goto EXIT

:FAIL
@echo    
@echo   Updating of IntelliDraw 2.01 was not successful, please correct any 
@echo   errors and run update.bat again
@echo    
del %IDPATH%\idraw.200 > nul
del %IDPATH%\PATCH.EXE > nul
del %IDPATH%\PATCH.RTP > nul
del %IDPATH%\PATCH.RTD > nul

:EXIT
